<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs" :large="false">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Dashboard Supervisión Mantenimiento</strong>
    </div>
    <div class="cotm">
      <div class="tmod">
        <strong>Dashboard Supervisión Mantenimiento</strong>
      </div>
    </div>
    <!-- Contenido -->
    <div class="contSecc">
      <div class="titSec">Filtro por año {{ periodo.periodicidad }}</div>
      <v-row cols>
        <v-col :cols="12" :xs="1" :sm="1" :md="1" :lg="1" :xl="1">
          {{ periodo.periodo }}
          <span class="tRojo">*</span>
          <v-select
            :items="fechaTrimestral.listaTrimestre"
            v-model="fechaTrimestral.trimestreSeleccionado"
            item-text="valorTrimestrar"
            v-on:change="cambioFecha"
          ></v-select>
        </v-col>
        <v-col :cols="12" :xs="1" :sm="1" :md="1" :lg="1" :xl="1">
          Año
          <span class="tRojo">*</span>
          <v-select
            :items="fechaTrimestral.listaAños"
            v-model="fechaTrimestral.añoSeleccionado"
            v-on:change="cambioFecha"
          ></v-select>
        </v-col>
        <v-col :cols="12" :xs="1" :sm="1" :md="1" :lg="1" :xl="1">
          Descargar Informe
          <div style="margin: 25px 10px 50px 10px">
            <v-btn color="primary" dark @click="downExcel()" class="btnDisabled">
              <strong style="fond-size: 16px; color: #000">Descargar a Excel</strong>
            </v-btn>
          </div>
        </v-col>
      </v-row>
      <div class="contenedorPrincipal">
        <v-row>
          <v-col :cols="12" :md="6" class="pl-8">
            <div class="titSec">
              Cobertura {{ periodo.periodicidad }} de supervisiones
            </div>
            <div class="gris">
              <div style="height: 20px"></div>

              <GraficaMediaCircularSupMto
                ref="mediaCircular"
                :name_id="valores1.filtros.name_id"
              />

              <Semaforo />
            </div>
          </v-col>
          <v-col :cols="12" :md="6" class="pr-8">
            <div class="titSec">
              Comparativa de cobertura semana actual vs semanas anteriores
            </div>
            <div class="gris">
              <GraficaBarrasComparativaSemanaSupMto
                ref="barraComparativaSemana"
                :name_id="valores3.filtros.name_id"
              />
            </div>
          </v-col>
        </v-row>
        <SliderCardsPorTerritoriosCoordinador ref="sliderCardTerritorios" />
      </div>
    </div>
    <!-- Fin conSecc -->
  </div>
</template>

<script>
import store from "@/store";
import axios from "axios";
const serviceLocalStorage = store.state.serviceLocalStorage;
const periodoSupervisionMtto = store.state.periodoSupervisionMtto;
import GraficaMediaCircularSupMto from "@/views/secure/supervision-mantenimiento/dashboard/componentes/GraficaMediaCircularSupMto.vue";
import GraficaBarrasComparativaSemanaSupMto from "@/views/secure/supervision-mantenimiento/dashboard/componentes/GraficaBarrasComparativaSemanaSupMto.vue";
import Semaforo from "@/views/secure/supervision-mantenimiento/dashboard/componentes/Semaforo.vue";
import FileSaver from "file-saver";
import SliderCardsPorTerritoriosCoordinador from "./componentes/SliderCardsPorTerritoriosCoordinador.vue";

export default {
  components: {
    GraficaMediaCircularSupMto,
    GraficaBarrasComparativaSemanaSupMto,
    Semaforo,
    SliderCardsPorTerritoriosCoordinador,
  },
  name: "supervision_mantenimiento_dashboard_coordinador",
  data() {
    return {
      user: { empleado: 0, nombre: "" },
      colores: ["#ff0000", "#ffcd00", "#19d228"],
      rangos: ["0,50", "51,89", "90,100"],
      objetoRangos: null,
      methodsSemaforo: null,
      periodo: {},
      territorios: [],
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Supervisión Mantenimiento",
          disabled: false,
          exact: true,
          to: {
            name: "supervision_mantenimiento_asignaciones_home",
          },
        },
        {
          text: "Dashboard Supervisión Mantenimiento",
          disabled: true,
        },
      ],

      fechaTrimestral: {
        listaAños: null,
        listaTrimestre: null,
        añoActual: 0,
        trimestreActual: null,
        fechaFinActual: null,
        añoSeleccionado: 0,
        trimestreSeleccionado: null,
      },
      fechaInicioFinTrimesreal: {
        fechaInicio: null,
        fechaFin: null,
        rangoSemanas: [],
      },
      fechaInicioFinAldia: {
        fechaInicio: null,
        fechaFin: null,
        rangoSemanas: [],
      },

      valores1: {
        grafica: 0,
        filtros: {
          value: 0,
          target1: 0,
          target2: 0,
          categoria: "",
          name_id: "mediaCircular",
          datos: [
            "de avance al dia de [bold]hoy[/]",
            "supervisiones programadas al trimestre",
          ],
          styleObject: {
            width: "100%",
            height: "310px",
            margin: "auto",
          },
          rColores: this.colores,
          rCalf: this.rangos,
        },
      },
      valores2: {
        grafica: 0,
        filtros: {
          value: 0,
          target: 0,
          categoria: "Categoria",
          name_id: "barraHorizontal",
          datos: [
            "Supervisiones realizadas al dia de hoy",
            "Supervisiones programadas al dia de hoy",
          ],
          styleObject: {
            width: "50%",
            height: "105px",
            margin: "auto",
          },
          rColores: this.colores,
          rCalf: this.rangos,
        },
      },
      valores3: {
        grafica: 0,
        filtros: {
          value: 0,
          target: 0,
          categoria: "",
          name_id: "barraComparativaSemana",
          datos: [],
          styleObject: {
            width: "100%",
            height: "410px",
            margin: "auto",
          },
          rColores: this.colores,
          rCalf: this.rangos,
        },
      },
    };
  },
  mounted() {
    this.getRangos();
    this.$root.$on("rangoloaded", this.setSemaforo);
  },
  methods: {
    cargaInicial() {
      this.years();
      this.trimestres();
      this.trimestreActual();
      this.getTerritorios();
      //this.cargaServicios();
    },
    getTerritorios() {
      let url1 = "/asignacion-mtto/secure/get/geografia";
      this.territorios = [];
      axios
        .post(url1, { territorio: null })
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                this.territorios = data
                  .filter((item) => item.idResponsable == this.user.empleado)
                  .map((item) => item.idTerritorio);
                console.log(
                  "territorios del usuario\n" + JSON.stringify(this.territorios)
                );
                this.cargaServicios();
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function () {});
    },

    cargaServicios() {
      this.seteaDatos();
      this.inicializaServicios();
      this.cargaServicioTrimestralGeneral();
    },
    cargaServicioTrimestralGeneral() {
      console.log(
        "this.fechaInicioFinAldia\n" + JSON.stringify(this.fechaInicioFinAldia)
      );
      console.log(
        "this.fechaInicioFinTrimesreal\n" + JSON.stringify(this.fechaInicioFinTrimesreal)
      );

      const self = this;
      //Graficos 1 y 2 (Realizados al trimestre)
      this.valores1.filtros.value = 0;
      this.valores2.filtros.value = 0;
      let url = "/asignacion-mtto/secure/get/conteoGeneralEchasCeco";
      this.territorios.forEach((item) => {
        this.fechaInicioFinTrimesreal.territorio = item;
        axios
          .post(url, this.fechaInicioFinTrimesreal)
          .then((response) => {
            if (response) {
              if (response.data.status_code === 200) {
                const data = response.data.data;
                if (data) {
                  console.log("conteoGeneralEchas\n" + JSON.stringify(data));
                  this.valores1.filtros.value += data[0].conteoRealizadas;
                  this.valores2.filtros.value += data[0].conteoRealizadas;
                  this.valores1.grafica = this.valores1.grafica - 1;
                  this.valores2.grafica = this.valores2.grafica - 1;
                  this.verificaCargaGrafico();
                }
              }
            }
          })
          .catch((error) => {
            console.log(error);
          })
          .finally(function () {});
      });
      //Graficos 2 (Programacion Trimestral)
      this.valores1.filtros.target1 = 0;
      var url2 = "/asignacion-mtto/secure/get/conteoGeneralProgramadasCeco";
      this.territorios.forEach((item) => {
        this.fechaInicioFinTrimesreal.territorio = item;
        axios
          .post(url2, this.fechaInicioFinTrimesreal)
          .then((response) => {
            if (response) {
              if (response.data.status_code === 200) {
                const data = response.data.data;
                if (data) {
                  console.log("conteoGeneralProgramadas1\n" + JSON.stringify(data));
                  this.valores1.filtros.target1 += data[0].conteoProgramadas;
                  this.valores1.grafica = this.valores1.grafica - 1;
                  this.verificaCargaGrafico();
                }
              }
            }
          })
          .catch((error) => {
            console.log(error);
          })
          .finally(function () {});
      });
      //Graficos 1 (Programacion al dia)
      this.valores1.filtros.target2 = 0;
      this.valores2.filtros.target = 0;
      this.territorios.forEach((item) => {
        this.fechaInicioFinAldia.territorio = item;
        axios
          .post(url2, this.fechaInicioFinAldia)
          .then((response) => {
            if (response) {
              if (response.data.status_code === 200) {
                const data = response.data.data;
                if (data) {
                  console.log("conteoGeneralProgramadas2\n" + JSON.stringify(data));

                  this.valores1.filtros.target2 += data[0].conteoProgramadas;
                  this.valores2.filtros.target += data[0].conteoProgramadas;
                  this.valores2.grafica = this.valores2.grafica - 1;
                  this.verificaCargaGrafico();
                }
              }
            }
          })
          .catch((error) => {
            console.log(error);
          })
          .finally(function () {});
      });

      //Grafico 3 (Semanal)
      let url4 = "/asignacion-mtto/secure/get/semanaTerritorio";
      this.valores3.filtros.datos = [];
      this.territorios.forEach((item) => {
        this.fechaInicioFinTrimesreal.territorio = item;
        axios
          .post(url4, this.fechaInicioFinTrimesreal)
          .then((response) => {
            if (response) {
              if (response.data.status_code === 200) {
                const data = response.data.data;
                console.log("conteoGeneralSemanal\n" + JSON.stringify(data));
                this.valores3.grafica = this.valores3.grafica - 1;
                this.preparaGraficaSemanal(data);
              }
            }
          })
          .catch((error) => {
            console.log(error);
          })
          .finally(function () {});
      });
    },

    verificaCargaGrafico() {
      if (this.valores1.grafica == 0 && this.valores2.grafica == 0) {
        this.valores1.grafica = 20;
        this.valores2.grafica = 20;
        this.$refs.mediaCircular.setValores(this.valores1.filtros);
      }
      if (this.valores3.grafica == 0) {
        this.valores3.grafica = 20;
        this.$refs.barraComparativaSemana.setValores(this.valores3.filtros);
      }
    },
    inicializaServicios() {
      var multiplo = this.territorios.length;
      this.valores1.grafica = 2 * multiplo;
      this.valores2.grafica = 2 * multiplo;
      this.valores3.grafica = 1 * multiplo;
    },

    seteaDatos() {
      switch (
        this.fechaTrimestral.trimestreSeleccionado //Modificar para cuatrimestre
      ) {
        case 1:
          this.fechaInicioFinAldia.fechaInicio =
            this.periodo.rango1[0] + this.fechaTrimestral.añoSeleccionado;
          this.fechaInicioFinTrimesreal.fechaInicio =
            this.periodo.rango1[0] + this.fechaTrimestral.añoSeleccionado;
          this.fechaInicioFinTrimesreal.fechaFin =
            this.periodo.rango1[1] + this.fechaTrimestral.añoSeleccionado;
          break;
        case 2:
          this.fechaInicioFinAldia.fechaInicio =
            this.periodo.rango2[0] + this.fechaTrimestral.añoSeleccionado;
          this.fechaInicioFinTrimesreal.fechaInicio =
            this.periodo.rango2[0] + this.fechaTrimestral.añoSeleccionado;
          this.fechaInicioFinTrimesreal.fechaFin =
            this.periodo.rango2[1] + this.fechaTrimestral.añoSeleccionado;
          break;
        case 3:
          this.fechaInicioFinAldia.fechaInicio =
            this.periodo.rango3[0] + this.fechaTrimestral.añoSeleccionado;
          this.fechaInicioFinTrimesreal.fechaInicio =
            this.periodo.rango3[0] + this.fechaTrimestral.añoSeleccionado;
          this.fechaInicioFinTrimesreal.fechaFin =
            this.periodo.rango3[1] + this.fechaTrimestral.añoSeleccionado;
          break;
        case 4:
          this.fechaInicioFinAldia.fechaInicio =
            this.periodo.rango4[0] + this.fechaTrimestral.añoSeleccionado;
          this.fechaInicioFinTrimesreal.fechaInicio =
            this.periodo.rango4[0] + this.fechaTrimestral.añoSeleccionado;
          this.fechaInicioFinTrimesreal.fechaFin =
            this.periodo.rango4[1] + this.fechaTrimestral.añoSeleccionado;
          break;
      }
      if (
        this.fechaTrimestral.fechaFinActual <= this.fechaInicioFinTrimesreal.fechaFin &&
        this.fechaTrimestral.añoActual == this.fechaTrimestral.añoSeleccionado &&
        this.fechaTrimestral.trimestreActual == this.fechaTrimestral.trimestreSeleccionado
      ) {
        this.fechaInicioFinAldia.fechaFin = this.fechaTrimestral.fechaFinActual;
      } else {
        this.fechaInicioFinAldia.fechaFin = this.fechaInicioFinTrimesreal.fechaFin;
      }

      this.fechaInicioFinAldia.rangoSemanas = this.obtienRangoSemanas(
        this.fechaInicioFinAldia.fechaInicio,
        this.fechaInicioFinAldia.fechaFin
      );
      this.fechaInicioFinTrimesreal.rangoSemanas = this.obtienRangoSemanas(
        this.fechaInicioFinTrimesreal.fechaInicio,
        this.fechaInicioFinTrimesreal.fechaFin
      );

      this.$refs.sliderCardTerritorios.seteaDatos(
        this.fechaTrimestral,
        this.fechaInicioFinTrimesreal,
        this.fechaInicioFinAldia,
        this.rangos,
        this.colores,
        this.user
      );
    },
    obtienRangoSemanas(fechasInicio, fechaFin) {
      var retorno = [];
      let diaIni = fechasInicio.substring(0, 2);
      let mesIni = fechasInicio.substring(2, 4) - 1;
      let añoIni = fechasInicio.substring(4, 8);
      let diaFin = fechaFin.substring(0, 2);
      let mesFin = fechaFin.substring(2, 4) - 1;
      let añoFin = fechaFin.substring(4, 8);

      let dIni = new Date(añoIni, mesIni, diaIni);
      let dFin = new Date(añoFin, mesFin, diaFin);
      dIni = new Date(Date.UTC(dIni.getFullYear(), dIni.getMonth(), dIni.getDate()));
      dFin = new Date(Date.UTC(dFin.getFullYear(), dFin.getMonth(), dFin.getDate()));
      dIni.setUTCDate(dIni.getUTCDate() + 4 - (dIni.getUTCDay() || 7));
      dFin.setUTCDate(dFin.getUTCDate() + 4 - (dFin.getUTCDay() || 7));
      var yearStartIni = new Date(Date.UTC(dIni.getUTCFullYear(), 0, 1));
      var yearStartFin = new Date(Date.UTC(dFin.getUTCFullYear(), 0, 1));
      var weekNoIni = Math.ceil(((dIni - yearStartIni) / 86400000 + 1) / 7);
      var weekNoFin = Math.ceil(((dFin - yearStartFin) / 86400000 + 1) / 7);
      if (weekNoIni != 0 && weekNoFin != 0) {
        if (weekNoIni == 53 || weekNoIni == 52) {
          retorno = [weekNoIni];
          weekNoIni = 1;
        }
        retorno = retorno.concat(
          Array.from(
            { length: weekNoFin + 1 - weekNoIni },
            (value, index) => index + weekNoIni
          )
        );
      }
      return retorno;
    },
    preparaGraficaSemanal(data) {
      for (var i = 0; i < this.fechaInicioFinTrimesreal.rangoSemanas.length; i++) {
        var elemento = undefined;
        if (data != undefined) {
          elemento = data.find(
            (dato) => dato.semana == this.fechaInicioFinTrimesreal.rangoSemanas[i]
          );
        }
        var elem = [];
        if (elemento == undefined) {
          elem = [
            {
              semana: "" + this.fechaInicioFinTrimesreal.rangoSemanas[i] + "",
              programacion: 0,
              realizado: 0,
            },
          ];
        } else {
          elem = [
            {
              semana: "" + this.fechaInicioFinTrimesreal.rangoSemanas[i] + "",
              programacion: elemento.conteoProgramadas,
              realizado: elemento.conteoRealizadas,
            },
          ];
        }
        var existe = this.valores3.filtros.datos.find(
          (item) => item.semana == "" + this.fechaInicioFinTrimesreal.rangoSemanas[i] + ""
        );
        if (existe) {
          existe.programacion += elem[0].programacion;
          existe.realizado += elem[0].realizado;
        } else {
          this.valores3.filtros.datos = this.valores3.filtros.datos.concat(elem);
        }

        //this.valores3.filtros.datos = this.valores3.filtros.datos.concat(elem);
      }
      this.verificaCargaGrafico();
    },

    years() {
      const year = new Date().getFullYear();
      var listaYears = Array.from(
        { length: year - 2019 },
        (value, index) => 2020 + index
      );
      this.fechaTrimestral.listaAños = listaYears.sort((a, b) => b - a);
    },
    trimestres() {
      this.fechaTrimestral.listaTrimestre = Array.from(
        { length: this.periodo.index }, //Modificar para cuatrimestre
        (value, index) => index + 1
      );
    },
    trimestreActual() {
      const fechaActual = new Date();
      let day = fechaActual.getDate();
      let month = fechaActual.getMonth() + 1;
      let year = fechaActual.getFullYear();

      if (month < 10) {
        if (day < 10) {
          this.fechaInicioFinAldia.fechaFin = "0" + day + "0" + month + "" + year;
          this.fechaTrimestral.fechaFinActual = "0" + day + "0" + month + "" + year;
        } else {
          this.fechaInicioFinAldia.fechaFin = day + "0" + month + "" + year;
          this.fechaTrimestral.fechaFinActual = day + "0" + month + "" + year;
        }
      } else {
        if (day < 10) {
          this.fechaInicioFinAldia.fechaFin = "0" + day + month + "" + year;
          this.fechaTrimestral.fechaFinActual = "0" + day + month + "" + year;
        } else {
          this.fechaInicioFinAldia.fechaFin = day + "" + month + "" + year;
          this.fechaTrimestral.fechaFinActual = day + "" + month + "" + year;
        }
      }
      this.fechaTrimestral.añoSeleccionado = fechaActual.getFullYear();
      this.fechaTrimestral.trimestreSeleccionado =
        Math.floor(fechaActual.getMonth() / this.periodo.divisor) + 1; //Modificar para cuatrimestre

      this.fechaTrimestral.añoActual = fechaActual.getFullYear();
      this.fechaTrimestral.trimestreActual =
        Math.floor(fechaActual.getMonth() / this.periodo.divisor) + 1; //Modificar para cuatrimestre
    },

    getRangos() {
      var self = this;
      axios
        .get("franquicia/rango/secure/get/numero/8")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              this.objetoRangos = data;
              this.generaRangos();
            } else {
              this.objetoRangos = [];
              this.generaRangos();
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function () {});
    },

    generaRangos() {
      if (this.objetoRangos != undefined && this.objetoRangos.length > 0) {
        var r,
          color,
          arrColor = [],
          arrR = [];
        this.objetoRangos = this.objetoRangos.sort(
          (a, b) => a.limite_inferior - b.limite_inferior
        );
        for (var i = 0; i < this.objetoRangos.length; i++) {
          r = [
            this.objetoRangos[i].limite_inferior +
              "," +
              this.objetoRangos[i].limite_superior,
          ];
          color = [this.objetoRangos[i].detalle];
          arrR = arrR.concat(r);
          arrColor = arrColor.concat(color);
        }
        this.colores = arrColor;
        this.rangos = arrR;
        this.valores1.filtros.rCalf = this.rangos;
        this.valores1.filtros.rColores = this.colores;
        this.valores2.filtros.rCalf = this.rangos;
        this.valores2.filtros.rColores = this.colores;
        this.valores3.filtros.rCalf = this.rangos;
        this.valores3.filtros.rColores = this.colores;
      }

      this.cargaInicial();
    },

    cambioFecha() {
      this.cargaServicios();
    },
    downExcel() {
      //DATA PARA DESCARGAR
      let objAdd = {
        fechaInicio: this.fechaInicioFinTrimesreal.fechaInicio,
        fechaFin: this.fechaInicioFinTrimesreal.fechaFin,
        territorio: null,
      };

      axios
        .post("/asignacion-mtto/secure/get/reporteProgramadas", objAdd)
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              console.log(JSON.stringify(response.data.data));

              const dataFinal = this.crearInfoExcel(response.data.data);

              axios({
                method: "post",
                url: "/json/convert/secure/array/excel",
                responseType: "blob",
                data: dataFinal,
              })
                .then((response) => {
                  console.log("La data COOR:" + response.data);

                  if (response.headers["content-type"] !== "application/json") {
                    FileSaver.saveAs(response.data, response.headers["file-name"]);
                  }
                })
                .catch((error) => {
                  console.log(error);
                })
                .finally(function () {});

              if ("undefined" == typeof response.data.data) {
                alert("FALLO MORTAL");
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function () {});
    },
    crearInfoExcel(data) {
      let datos = data;
      data = data.filter((item) => this.territorios.includes(item.idTerritorio));

      let xlsInfo = [];
      let fields = [
        //  0-Header Excel    1-Dato desde DB
        ["TERRITORIO", "territorio"],
        ["ZONA", "zona"],
        ["CECO", "idCeco"],
        ["NOMBRE_CECO", "nombreCeco"],
        ["USUARIO", "idUsuario"],
        ["NOMBRE_USUARIO", "nombreUsuario"],
        ["ESTATUS", "estatus"],
        ["REPROGRAMADA", "reprogramada"],
        ["MOTIVO_REPROGRAMACION", "comentarioReprogramacion"],
        ["FECHA_PROGRAMADA", "fechaProgramada"],
        //["FECHA_REALIZADA", "fechaRealizada"]
      ];
      for (var i = 0; i < data.length; i++) {
        let ass = new Object();
        for (var j = 0; j < fields.length; j++) {
          if (fields[j][0] == "REPROGRAMADA") {
            ass.REPROGRAMADA = eval(
              "typeof(datos[i]." + fields[j][1] + ") == 'undefined' ? 'NO' : 'SI'"
            );
          } else {
            let instrucc =
              "ass." +
              fields[j][0] +
              " = typeof(datos[i]." +
              fields[j][1] +
              ") == 'undefined' ? '' : " +
              "datos[i]." +
              fields[j][1];

            eval(instrucc);
          }
        }
        xlsInfo.push(ass);
      }
      return xlsInfo;
    },
    setSemaforo(methodsSemaforo) {
      this.methodsSemaforo = methodsSemaforo;
    },
  },
  created() {
    this.user = serviceLocalStorage.userToken();
    this.periodo = periodoSupervisionMtto;
    this.valores1.filtros.datos[1] =
      "supervisiones programadas al " + this.periodo.periodo;
  },
  computed: {},
  watch: {},
};
//espacio
</script>

<style></style>
